# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (c) 2010 Domatix Technologies  S.L. (http://www.domatix.com) 
#                       info <info@domatix.com>
#                        Angel Moya <angel.moya@domatix.com>
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import fields, osv   
import decimal_precision as dp


class sale_order_line(osv.osv):  
    
    _inherit = 'sale.order.line'
    
    
    def _delivered_qty(self, cr, uid, ids, field_name, arg, context=None):
        move_obj = self.pool.get('stock.move')
        res = {}
        for line in self.browse(cr, uid, ids, context=context):
            qty = 0
            
            for move in line.move_ids:
                if move.state == 'done':
                    qty += move.product_qty
                    
            res[line.id] = qty
        return res
    
    def _product_available(self, cr, uid, ids, field_names=None, arg=False, context=None):
        """ Finds the incoming and outgoing quantity of product.
        @return: Dictionary of values
        """

        if context is None:
            context = {}
        res = {}
        
        for line in self.browse(cr,uid,ids,context):
            res[line.id] = {'qty_available': line.product_id and line.product_id.qty_available,
                            'virtual_available': line.product_id and line.product_id.virtual_available}
        return res
    
    _columns={
        'delivered_qty': fields.function(_delivered_qty, digits_compute=dp.get_precision('Product UoM'), string='Delivered Qty'),
        'qty_available': fields.function(_product_available, multi='qty_available',
            type='float',  digits_compute=dp.get_precision('Product UoM'),
            string='Quantity On Hand'),
        'virtual_available': fields.function(_product_available, multi='qty_available',
            type='float',  digits_compute=dp.get_precision('Product UoM'),
            string='Quantity Available')
        }
        
    
sale_order_line()  